/** open.c
 **
 ** Omnigo/Unix file transfer program.
 **
 ** Written by and Copyright 1996 Asher Hoskins.
 ** Modified by Marcus Groeber for use under OS/2.
 **
 ** The author retains copyright on this implementation. Permission for
 ** educational and non-profit use is granted to all. If you're planning to
 ** make money with this or any code derived from it, check with the author
 ** first.
 **
 ** See README file for more information.
 **
 ** Open a connection to the Omnigo.
 **/


#include <stdio.h>
#include <io.h>
#include <fcntl.h>

#define INCL_BASE
#define INCL_DOSDEVIOCTL
#include <os2.h>

#pragma pack(1)

int openOmnigo(char *port, unsigned int speed) {

	int tty;
	ULONG paramlen;

	USHORT param_setbaud=(USHORT)speed;
	struct { BYTE data; BYTE parity; BYTE stop; } param_setline={8,0,0};

	if ((tty=open(port, O_RDWR)) == -1) {
		fputs("Couldn't open port!\n", stderr);
		exit(1);
	}

	DosDevIOCtl(tty, IOCTL_ASYNC, ASYNC_SETBAUDRATE,
		&param_setbaud, sizeof(param_setbaud), &paramlen, NULL, 0, 0);

	DosDevIOCtl(tty, IOCTL_ASYNC, ASYNC_SETLINECTRL,
		&param_setline, sizeof(param_setline), &paramlen, NULL, 0, 0);

	return(tty);
}
